// 005 u_find_memo
// 12 jun 2005

// -- (C) Felix John COLIBRI 2007
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_bfs_02_create_table_net;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Borland.Vcl.StdCtrls, Borland.Vcl.ExtCtrls, System.ComponentModel,
  DBXpress, Borland.Vcl.Db, Borland.Vcl.SqlExpr;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    create_w_sql_connection_: TButton;
    SQLConnection1: TSQLConnection;
    drop_w_sql_connection_: TButton;
    create_w_db_connection_: TButton;
    drop_w_db_connection_: TButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure create_w_sql_connection_Click(Sender: TObject);
    procedure drop_w_sql_connection_Click(Sender: TObject);
    procedure create_w_db_connection_Click(Sender: TObject);
    procedure drop_w_db_connection_Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
  uses
       system.data // CommandType
      , system.data.common // dbConnection

      , u_c_vcl_net_log
      , u_c_vcl_net_display
      ;

{$R *.nfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    const
          k_registering_table_name= 'registering';
          k_create_registering=
              'CREATE TABLE '+ k_registering_table_name
            + '  (r_id INTEGER, r_training_ref INTEGER, r_company CHAR(15), r_trainee CHAR(15) )';

          k_drop_registering=
              'DROP TABLE '+ k_registering_table_name;

    procedure execute_request(p_sql_request: String);
      begin
        with Form1 do
        begin
          display('> execute '+ p_sql_request);
          Try
            Try
              SqlConnection1.Open;
              SqlConnection1.ExecuteDirect(p_sql_request);
              display('  ok');
            Except
              on e: Exception do
                display('  *** error '+ e.Message);
            end;
          finally
            SqlConnection1.Close;
          end;
          display('< execute');
        end; // with Form1
      end; // execute_request

    procedure TForm1.create_w_sql_connection_Click(Sender: TObject);
      begin
        execute_request(k_create_registering);
      end; // create_sql_connection_Click

    procedure TForm1.drop_w_sql_connection_Click(Sender: TObject);
      begin
        execute_request(k_drop_registering);
      end; // drop_w_sql_connection_Click

    // -- dbConnection

    const // k_database_file_name= 'C:\Documents and Settings\All Users.WINDOWS\Documents\RAD Studio\5.0\Demos\databases\BlackfishSQL\employee.jds';
          k_database_file_name= 'C:\programs\us\db\blackfishsql\_data\training.jds';

    function f_c_db_connection: DbConnection;
      var l_c_db_provider_factory: DbProviderFactory;
      begin
        l_c_db_provider_factory:= DbProviderFactories.GetFactory('Borland.Data.BlackfishSQL.LocalClient');

        Result:= l_c_db_provider_factory.CreateConnection();

        Result.ConnectionString:=
               'host=LocalHost'
             + ';database='+ k_database_file_name
             + ';user=SYSDBA'
             + ';password=masterkey'
             + ';create=True'
             ;
      end; // f_c_db_connection

    procedure execute_db_request_non_select(p_sql_request: String);
      const k_with_transaction= True;
      var l_c_db_connection: DbConnection;
          l_c_db_transaction: DbTransaction;
          l_c_db_command: DbCommand;
      begin
        display_line;
        display('> execute_db_non_query '+ p_sql_request);

        Try
          Try
            l_c_db_connection:= f_c_db_connection;
            l_c_db_connection.Open;
            if k_with_transaction
              then l_c_db_transaction:= l_c_db_connection.BeginTransaction;


            l_c_db_command:= l_c_db_connection.CreateCommand;
            l_c_db_command.CommandText:= p_sql_request;
            l_c_db_command.CommandType:= CommandType.Text;

            l_c_db_command.ExecuteNonQuery;
            if k_with_transaction
              then l_c_db_transaction.Commit;

            display('  ok');
          except
            on e: exception do
              begin
                display_bug_stop('  *** error '+ e.Message);
                if k_with_transaction
                  then l_c_db_transaction.RollBack;
              end;
          end;

        finally
          l_c_db_connection.Close;
        end;

        display('< execute_db_non_query');
      end; // execute_db_request_non_select

    procedure TForm1.create_w_db_connection_Click(Sender: TObject);
      begin
        execute_db_request_non_select(k_create_registering);
      end; // create_w_dbconnection_Click

    procedure TForm1.drop_w_db_connection_Click(Sender: TObject);
      begin
        execute_db_request_non_select(k_drop_registering);
      end; // drop_w_db_connection_Click



end.



